c60ae1b54f72369625a26b46905a158d21080232
[xfstests-dev.git] / common.rc
1 ##/bin/sh
2
3 #
4 # Copyright (c) 2000 Silicon Graphics, Inc.  All Rights Reserved.
5
6 # This program is free software; you can redistribute it and/or modify it
7 # under the terms of version 2 of the GNU General Public License as
8 # published by the Free Software Foundation.
9
10 # This program is distributed in the hope that it would be useful, but
11 # WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
13
14 # Further, this software is distributed without any warranty that it is
15 # free of the rightful claim of any third person regarding infringement
16 # or the like.  Any license provided herein, whether implied or
17 # otherwise, applies only to this software file.  Patent licenses, if
18 # any, provided herein do not apply to combinations of this program with
19 # other software, or any other product whatsoever.
20
21 # You should have received a copy of the GNU General Public License along
22 # with this program; if not, write the Free Software Foundation, Inc., 59
23 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
24
25 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
26 # Mountain View, CA  94043, or:
27
28 # http://www.sgi.com 
29
30 # For further information regarding this notice, see: 
31
32 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
33 #
34
35 # we need common.config
36 if ! . ./common.config
37 then
38     echo "$iam: failed to source common.config"
39     exit 1
40 fi
41
42 # awk
43 AWK_PROG=awk
44
45 # ps
46 PS_HAVE_BSD=false
47 PS_ALL_FLAGS=-efw
48
49 # host os
50 PLATFORM=linux
51
52 # extra parameters for fsstress
53 FSSTRESS_AVOID="-f resvsp=0 -f unresvsp=0"
54
55 export AWK_PROG PS_HAVE_BSD PS_ALL_FLAGS PLATFORM
56
57 # we override mount so we can specify mount options
58
59 mount()
60 {
61     case "$*"
62     in
63         *remount*)
64             /bin/mount $*
65             ;;
66         *ext2*)
67             /bin/mount $*
68             ;;
69         *xfs*)
70             /bin/mount $* $MOUNT_OPTIONS
71             ;;
72         *)
73             /bin/mount $*
74             ;;
75     esac
76 }
77
78 #
79
80 _get_pids_by_name()
81 {
82     if [ $# -ne 1 ]
83     then
84         echo "Usage: _get_pids_by_name process-name" 1>&2
85         exit 1
86     fi
87
88     # Algorithm ... all ps(1) variants have a time of the form MM:SS or
89     # HH:MM:SS before the psargs field, use this as the search anchor.
90     #
91     # Matches with $1 (process-name) occur if the first psarg is $1
92     # or ends in /$1 ... the matching uses sed's regular expressions,
93     # so passing a regex into $1 will work.
94
95     ps $PS_ALL_FLAGS \
96     | sed -n \
97         -e 's/$/ /' \
98         -e 's/[         ][      ]*/ /g' \
99         -e 's/^ //' \
100         -e 's/^[^ ]* //' \
101         -e "/[0-9]:[0-9][0-9]  *[^ ]*\/$1 /s/ .*//p" \
102         -e "/[0-9]:[0-9][0-9]  *$1 /s/ .*//p"
103 }
104
105 # fqdn for localhost
106 #
107 _get_fqdn()
108 {
109     host=`hostname`
110     nslookup $host | $AWK_PROG '{ if ($1 == "Name:") print $2 }'
111 }
112
113 # fix malloc libs output
114 #
115 _fix_malloc()
116 {
117     # filter out the Electric Fence notice
118     perl -e '
119         while (<>) {
120             if (defined $o && /^\s+Electric Fence/) {
121                 chomp($o);
122                 print "$o";
123                 undef $o;
124                 next;
125             }
126             print $o if (defined $o);
127
128             $o=$_;
129         }
130         print $o if (defined $o);
131     '
132 }
133
134 # check if run as root
135 #
136 _need_to_be_root()
137 {
138     id=`id | sed -e 's/(.*//' -e 's/.*=//'`
139     if [ "$id" -ne 0 ]
140     then
141         echo "Arrgh ... you need to be root (not uid=$id) to run this test"
142         exit 1
143     fi
144 }
145
146
147 #
148 # _df_device : get an IRIX style df line for a given device 
149 #
150 #       - returns "" if not mounted
151 #       - returns fs type in field two (ala IRIX)
152 #       - joins line together if split by fancy df formatting
153 #       - strips header etc
154 #
155
156 _df_device()
157 {
158     if [ $# -ne 1 ]
159     then
160         echo "Usage: _df_device device" 1>&2
161         exit 1
162     fi
163     
164     df -T 2>/dev/null | $AWK_PROG -v what=$1 '
165         match($1,what) && NF==1 { 
166             v=$1
167             getline
168             print v, $0
169             exit
170         }
171         match($1,what) {
172             print
173             exit
174         }
175     '
176 }
177
178 #
179 # _df_dir : get an IRIX style df line for device where a directory resides
180 #
181 #       - returns fs type in field two (ala IRIX)
182 #       - joins line together if split by fancy df formatting
183 #       - strips header etc
184 #
185
186 _df_dir()
187 {
188     if [ $# -ne 1 ]
189     then
190         echo "Usage: _df_dir device" 1>&2
191         exit 1
192     fi
193     
194     df -T $1 2>/dev/null | $AWK_PROG -v what=$1 '
195         NR == 2 && NF==1 { 
196             v=$1
197             getline 
198             print v, $0;
199             exit 0
200         }
201         NR == 2 {
202             print;
203             exit 0
204         }
205         {}
206     '
207     # otherwise, nada
208 }
209
210 # return percentage used disk space for mounted device
211
212 _used()
213 {
214     if [ $# -ne 1 ]
215     then
216         echo "Usage: _used device" 1>&2
217         exit 1
218     fi
219     
220     _df_device $1 | $AWK_PROG '{ sub("%", "") ; print $6 }'
221 }
222
223 # return the FS type of a mounted device
224 #
225 _fs_type()
226 {
227     if [ $# -ne 1 ]
228     then
229         echo "Usage: _fs_type device" 1>&2
230         exit 1
231     fi
232     
233     _df_device $1 | $AWK_PROG '{ print $2 }'
234 }
235
236 # return the FS mount options of a mounted device
237 #
238 _fs_options()
239 {
240     if [ $# -ne 1 ]
241     then
242         echo "Usage: _fs_options device" 1>&2
243         exit 1
244     fi
245     
246     $AWK_PROG -v dev=$1 '
247         match($1,dev) { print $4 }
248     ' </proc/mounts
249     
250 }
251
252 # returns device number if a file is a block device
253 #
254 _is_block_dev()
255 {
256     if [ $# -ne 1 ]
257     then
258         echo "Usage: _is_block_dev dev" 1>&2
259         exit 1
260     fi
261     
262     [ -b $1 ] && src/lstat64 $1 | $AWK_PROG '/Device type:/ { print $9 }'
263 }
264
265 # Do a command, log it to $seq.full, optionally test return status
266 # and die if command fails. If called with one argument _do executes the
267 # command, logs it, and returns its exit status. With two arguments _do
268 # first prints the message passed in the first argument, and then "done"
269 # or "fail" depending on the return status of the command passed in the
270 # second argument. If the command fails and the variable _do_die_on_error
271 # is set to "always" or the two argument form is used and _do_die_on_error
272 # is set to "message_only" _do will print an error message to
273 # $seq.out and exit.
274
275 _do()
276 {
277   if [ $# -eq 1 ]; then
278     _cmd=$1
279   elif [ $# -eq 2 ]; then
280     _note=$1
281     _cmd=$2
282     echo -n "$_note... "
283   else
284     echo "Usage: _do [note] cmd" 1>&2
285     status=1; exit
286   fi
287
288   (eval "echo '---' \"$_cmd\"") >>$seq.full
289   (eval "$_cmd") >$tmp._out 2>&1; ret=$?
290   cat $tmp._out | _fix_malloc >>$seq.full
291   if [ $# -eq 2 ]; then
292     if [ $ret -eq 0 ]; then
293       echo "done"
294     else
295       echo "fail"
296     fi
297   fi
298   if [ $ret -ne 0  ] \
299      && [ "$_do_die_on_error" = "always" \
300          -o \( $# -eq 2 -a "$_do_die_on_error" = "message_only" \) ]
301   then
302       [ $# -ne 2 ] && echo
303       eval "echo \"$_cmd\" failed \(returned $ret\): see $seq.full"
304       status=1; exit
305   fi
306
307   return $ret
308 }
309
310 # bail out, setting up .notrun file
311
312 _notrun()
313 {
314     echo "$*" >$seq.notrun
315     echo "$seq not run: $*"
316     status=0
317     exit
318 }
319
320 # just plain bail out
321
322 _fail()
323 {
324     echo "$*" | tee -a $seq.full
325     echo "(see $seq.full for details)"
326     status=1
327     exit 1
328 }
329
330 # this test needs a scratch partition - check we're ok & unmount it
331
332 _require_scratch()
333 {
334
335     if [ -z "$SCRATCH_DEV" -o "`_is_block_dev $SCRATCH_DEV`" = "" ]
336     then
337         _notrun "this test requires a valid \$SCRATCH_DEV"
338     fi
339     
340     if [ "`_is_block_dev $SCRATCH_DEV`" = "`_is_block_dev $TEST_DEV`" ]
341     then
342         _notrun "this test requires a valid \$SCRATCH_DEV"
343     fi
344     
345     # mounted?
346     if mount | grep -q $SCRATCH_DEV
347     then 
348         # if it's mounted, make sure its on $SCRATCH_MNT
349         if ! mount | grep $SCRATCH_DEV | grep -q $SCRATCH_MNT
350         then 
351             echo "\$SCRATCH_DEV is mounted but not on \$SCRATCH_MNT - aborting"
352             exit 1
353         fi
354         
355         # and then unmount it
356     
357         if ! umount $SCRATCH_DEV
358         then
359             echo "failed to unmount $SCRATCH_DEV"
360             exit 1
361         fi
362     fi
363     
364     # should be ok now
365
366 }
367
368 # this test needs a logdev 
369
370 _require_logdev()
371 {
372     if [ -z "$SCRATCH_LOGDEV" -o ! -b "$SCRATCH_LOGDEV" ]
373     then
374         _notrun "This test requires a valid \$SCRATCH_LOGDEV" 
375     fi
376 }
377
378 # this test requires loopback device support
379
380 _require_loop()
381 {
382     if grep loop /proc/devices >/dev/null 2>&1
383     then
384         :
385     else
386         _notrun "This test requires loopback device support"
387     fi
388 }
389
390
391 # check that a FS is mounted as XFS. if so, return mount point
392 #
393 _xfs_mounted()
394 {
395     if [ $# -ne 1 ]
396     then
397         echo "Usage: _xfs_mounted device" 1>&2
398         exit 1
399     fi
400     
401     device=$1
402     
403     if mount | grep $device | $AWK_PROG '
404         /type xfs/  { print $3 ; exit 0 }
405         END         { exit 1 }
406     '
407     then
408         echo "_xfs_mounted: $device is not a mounted XFS FS"
409         exit 1
410     fi
411 }
412
413 # remount a FS to a new mode (ro or rw)
414 #
415
416 _remount()
417 {
418     if [ $# -ne 2 ]
419     then
420         echo "Usage: _remount device ro/rw" 1>&2
421         exit 1
422     fi
423     device=$1
424     mode=$2
425     
426     if ! mount -o remount,$mode $device
427     then
428         echo "_remount: failed to remount filesystem on $device as $mode"
429         exit 1
430     fi
431     
432     # we might like to check here later
433     #options=`_fs_options $device`
434
435 }
436
437 # run xfs_check on a FS. 
438 #
439 # if the filesystem is mounted, it's either remounted ro before being
440 # checked or it's unmounted and then remounted
441 #
442
443 USE_REMOUNT=0
444
445 _check_fs()
446 {
447     if [ $# -ne 1 ]
448     then
449         echo "Usage: _check_fs device" 1>&2
450         exit 1
451     fi
452     
453     device=$1
454     type=`_fs_type $device`
455     ok=1
456     
457     if [ "$type" = "xfs" ]
458     then
459         # mounted... 
460         
461         if [ $USE_REMOUNT -eq 0 ]
462         then
463             mountpoint=`_xfs_mounted $device`
464             umount $device
465         else
466             _remount $device ro
467         fi
468     fi
469
470     xfs_logprint -t $device 2>&1 | tee $tmp.fs_check | grep -q "<CLEAN>"
471     if [ $? -ne 0 ]
472     then
473         echo "_check_fs: filesystem on $device has dirty log (see $seq.full)"
474         
475         echo "_check_fs: filesystem on $device has dirty log"   >>$seq.full
476         echo "*** xfs_logprint -t output ***"                   >>$seq.full
477         cat $tmp.fs_check                                       >>$seq.full
478         echo "*** end xfs_logprint output"                      >>$seq.full
479         
480         ok=0
481     fi
482         
483     
484     xfs_check $device 2>&1 | _fix_malloc >$tmp.fs_check 
485     if [ -s $tmp.fs_check ]
486     then
487         echo "_check_fs: filesystem on $device is inconsistent (c) (see $seq.full)"
488         
489         echo "_check_fs: filesystem on $device is inconsistent" >>$seq.full
490         echo "*** xfs_check output ***"                         >>$seq.full
491         cat $tmp.fs_check                                       >>$seq.full
492         echo "*** end xfs_check output"                         >>$seq.full
493         
494         ok=0
495     fi
496     
497     if ! xfs_repair -n $device >$tmp.fs_check 2>&1
498     then
499         echo "_check_fs: filesystem on $device is inconsistent (r) (see $seq.full)"
500         
501         echo "_check_fs: filesystem on $device is inconsistent" >>$seq.full
502         echo "*** xfs_repair -n output ***"                     >>$seq.full
503         cat $tmp.fs_check | _fix_malloc                         >>$seq.full
504         echo "*** end xfs_repair output"                        >>$seq.full
505         
506         ok=0
507     fi
508     rm -f $tmp.fs_check
509     
510     if [ $ok -eq 0 ]
511     then
512         echo "*** mount output ***"                             >>$seq.full
513         mount                                                   >>$seq.full
514         echo "*** end mount output"                             >>$seq.full
515     fi
516     
517     if [ "$type" = "xfs" ]
518     then
519         # mounted... 
520         if [ $USE_REMOUNT -eq 0 ]
521         then
522             if ! mount -t xfs $device $mountpoint
523             then
524                 echo "!!! failed to remount $device on $mountpoint"
525                 ok=0
526             fi
527         else
528             _remount $device rw
529         fi
530     fi
531     
532     [ $ok -eq 0 ] && exit 1
533     return 0    
534 }
535
536 ################################################################################
537
538 [ -d /usr/bsd ] && PATH=$PATH:/usr/bsd
539 [ -d /usr/freeware/bin ] && PATH=$PATH:/usr/freeware/bin
540
541 if [ "$iam" != new ]
542 then
543
544     # make some further configuration checks here
545     
546     if [ "$TEST_DEV" = ""  ]
547     then
548         echo "common.rc: Error: \$TEST_DEV is not set"
549         exit 1
550     fi
551     
552     if [ "`_fs_type $TEST_DEV`" != "xfs" ]
553     then
554         echo "common.rc: Error: \$TEST_DEV ($TEST_DEV) is not a MOUNTED XFS filesystem"
555         df -T $TEST_DEV
556         exit 1
557     fi
558
559 fi
560
561 # check for some required biunaries on our $PATH
562 #
563 for exec in mkfs.xfs xfs_logprint xfs_check xfs_repair xfs_db
564 do
565     if which $exec >/dev/null 2>&1 
566     then
567         :
568     else
569         echo "common.rc: cannot find $exec on \$PATH=$PATH"
570         exit 1
571     fi
572 done
573
574 # make sure this script returns success
575 /bin/true